diff --git a/drupal7/sites/all/modules/media/modules/media_internet/tests/media_internet_test.module b/drupal7/sites/all/modules/media/modules/media_internet/tests/media_internet_test.module
new file mode 100644
index 00000000..ee1279aa
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_internet/tests/media_internet_test.module
@@ -0,0 +1,50 @@
+<?php
+
+/**
+ * @file
+ * Provides Media Internet module hook implementations for testing purposes.
+ */
+
+/**
+ * Implements hook_media_internet_providers().
+ */
+function media_internet_test_media_internet_providers() {
+  return array(
+    'MediaInternetTestHandler' => array(
+      'title' => t('Media Internet Test'),
+    ),
+  );
+}
+
+/**
+ * Implements hook_stream_wrappers().
+ */
+function media_internet_test_stream_wrappers() {
+  return array(
+    'mediainternettest' => array(
+      'name' => t('Media Internet Test'),
+      'class' => 'MediaInternetTestStreamWrapper',
+      'description' => t('Media Internet Test.'),
+      'type' => STREAM_WRAPPERS_READ_VISIBLE,
+    ),
+  );
+}
+
+/**
+ * Implements hook_media_parse().
+ *
+ * @todo This hook should be deprecated. Refactor Media module to not call it
+ *   any more, since media_internet should be able to automatically route to the
+ *   appropriate handler.
+ */
+function media_internet_test_media_parse($embed_code) {
+  $handler = new MediaInternetTestHandler($embed_code);
+  return $handler->parse($embed_code);
+}
+
+ /**
+ * Implements hook_file_mimetype_mapping_alter().
+ */
+function media_internet_test_file_mimetype_mapping_alter(&$mapping) {
+  $mapping['mimetypes'][] = 'video/mediainternettest';
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_migrate_file_types/includes/media_migrate_file_types.pages.inc b/drupal7/sites/all/modules/media/modules/media_migrate_file_types/includes/media_migrate_file_types.pages.inc
new file mode 100644
index 00000000..e88bda13
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_migrate_file_types/includes/media_migrate_file_types.pages.inc
@@ -0,0 +1,199 @@
+<?php
+
+/**
+ * @file
+ * Common pages for the Media Migrate File Types module.
+ */
+
+/**
+ * File type migration page.
+ *
+ * Allows site administrator to execute migration of old/disabled/deleted
+ * file types to new ones.
+ */
+function media_migrate_file_types_upgrade_file_types($form, &$form_state) {
+  $migratable_types = _media_migrate_file_types_get_migratable_file_types();
+
+  // Silently return if there are no file types that need migration.
+  if (empty($migratable_types)) {
+    return array(
+      'message' => array(
+        '#markup' => t('There are no file types that need migration. The Media Medigrate File Types module can now be safely <a href="@modules">disabled</a>.', array('@modules' => url('admin/modules'))),
+      ),
+    );
+  }
+
+  $form['message'] = array(
+    'message' => array(
+      '#markup' => t('This page allows you to migrate deprecated and/or disabled file types to new ones. It will migrate files from old type to new one and optionally migrate fields and delete old type.'),
+    ),
+  );
+
+  $form['migrate_fields'] = array(
+    '#type' => 'checkbox',
+    '#title' => t('Migrate fields'),
+    '#default_value' => TRUE,
+    '#description' => t('Migrate fields and their values from old file types to new ones.'),
+  );
+  $form['delete_old_type'] = array(
+    '#type' => 'checkbox',
+    '#title' => t('Delete old type'),
+    '#default_value' => FALSE,
+    '#description' => t('Delete old file type if migration was successful and delete operation is possible (type is not exported in code).'),
+  );
+  $form['migrate_mimes'] = array(
+    '#type' => 'checkbox',
+    '#title' => t('Migrate type mime-type'),
+    '#default_value' => TRUE,
+    '#description' => t('Move mime-type from old type to new one.'),
+  );
+
+  $form['upgradable_types'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Upgradable file types'),
+  );
+
+  $options = array('- ' . t('Do not upgrade') . ' -');
+  foreach (file_type_get_enabled_types() as $type) {
+    $options[$type->type] = $type->label;
+  }
+
+  foreach ($migratable_types as $machine_name) {
+    $type = file_type_load($machine_name);
+    if (!$type) {
+      $type = new stdClass;
+      $type->label = $type->type = $machine_name;
+    }
+    $form['upgradable_types'][$machine_name] = array(
+      '#type' => 'select',
+      '#title' => $type->label,
+      '#options' => $options,
+      '#description' => t(
+        'Select file type which you want to migrate @type to. Select %no_upgrade if type should stay as it is.',
+        array('@type' => $type->label, '%no_upgrade' => '- ' . t('Do not upgrade') . ' -')),
+    );
+  }
+
+  $form['submit'] = array(
+    '#type' => 'submit',
+    '#value' => t('Start migration'),
+  );
+
+  return $form;
+}
+
+/**
+ * File type migration page submit handler.
+ */
+function media_migrate_file_types_upgrade_file_types_submit($form, &$form_state) {
+  $migratable_types = _media_migrate_file_types_get_migratable_file_types();
+  $migrate = FALSE;
+  foreach ($migratable_types as $type) {
+    if ($form_state['values'][$type]) {
+      $migrate = TRUE;
+      break;
+    }
+  }
+
+  // Return silently if no types were selected for migration.
+  if (!$migrate) {
+    return;
+  }
+
+  // Use confirmation page/form.
+  $query = $form_state['values'];
+  unset($query['op']);
+  unset($query['submit']);
+  unset($query['form_id']);
+  unset($query['form_token']);
+  unset($query['form_build_id']);
+
+  $form_state['redirect'] = array(
+    'admin/structure/file-types/upgrade/confirm',
+    array('query' => $query),
+  );
+}
+
+/**
+ * File types migration confirmation page.
+ */
+function media_migrate_file_types_upgrade_file_types_confirm($form, &$form_state) {
+  return confirm_form(
+    $form,
+    t('Do you really want to migrate selected file types?'),
+    'admin/structure/file-types/upgrade',
+    NULL,
+    t('Migrate')
+  );
+}
+
+/**
+ * File types migration confirmation page submit. Executes actual migration.
+ */
+function media_migrate_file_types_upgrade_file_types_confirm_submit($form, &$form_state) {
+  $migratable_types = _media_migrate_file_types_get_migratable_file_types();
+  foreach ($migratable_types as $type) {
+    if ($_GET[$type] && $bundle_new = file_type_load($_GET[$type])) {
+      // Old bundle might be deleted so let's fake some values.
+      $bundle_old = file_type_load($type);
+      if (empty($bundle_old)) {
+        $bundle_old = new stdClass;
+        $bundle_old->type = $type;
+        $bundle_old->mimetypes = array();
+        $bundle_old->export_type = 2;
+      }
+
+      // Migrate fields to new bundle.
+      if ($_GET['migrate_fields']) {
+        $old_fields = db_select('field_config_instance', 'fc')->fields('fc', array('field_name'))->condition('entity_type',  'file')->condition('bundle', $bundle_old->type)->execute()->fetchCol();
+        $new_fields = db_select('field_config_instance', 'fc')->fields('fc', array('field_name'))->condition('entity_type',  'file')->condition('bundle', $bundle_new->type)->execute()->fetchCol();
+        $fields_to_move = array_diff($old_fields, $new_fields);
+        $fields_to_drop = array_diff($old_fields, $fields_to_move);
+
+        db_update('field_config_instance')
+          ->fields(array('bundle' => $bundle_new->type))
+          ->condition('entity_type',  'file')
+          ->condition('bundle', $bundle_old->type)
+          ->condition('field_name', $fields_to_move, 'IN')
+          ->execute();
+
+        db_delete('field_config_instance')
+          ->condition('entity_type',  'file')
+          ->condition('bundle', $bundle_old->type)
+          ->condition('field_name', $fields_to_drop, 'IN')
+          ->execute();
+
+        field_cache_clear();
+        module_invoke_all('field_attach_rename_bundle', 'file', $bundle_old->type, $bundle_new->type);
+      }
+
+      // Migrate mimetypes to new bundle.
+      if ($_GET['migrate_mimes']) {
+        $changed = FALSE;
+        foreach ($bundle_old->mimetypes as $mime) {
+          if (!file_entity_match_mimetypes($bundle_new->mimetypes, $mime)) {
+            $bundle_new->mimetypes[] = $mime;
+            $changed = TRUE;
+          }
+        }
+
+        if ($changed) {
+          file_type_save($bundle_new);
+        }
+      }
+
+      // Delete old bundle.
+      if ($_GET['delete_old_type'] && $bundle_old->export_type == 1) {
+        file_type_delete($bundle_old);
+      }
+
+      // Migrate files.
+      db_update('file_managed')
+        ->fields(array('type' => $bundle_new->type))
+        ->condition('type', $bundle_old->type)
+        ->execute();
+    }
+  }
+
+  $form_state['redirect'] = 'admin/structure/file-types';
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_migrate_file_types/media_migrate_file_types.info b/drupal7/sites/all/modules/media/modules/media_migrate_file_types/media_migrate_file_types.info
new file mode 100644
index 00000000..0031d93f
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_migrate_file_types/media_migrate_file_types.info
@@ -0,0 +1,16 @@
+name = Media Migrate File Types
+description = Provides a UI for updating legacy media types with the new file types provided by File Entity.
+package = Media
+core = 7.x
+hidden = TRUE
+
+dependencies[] = media
+
+configure = admin/structure/file-types/upgrade
+
+; Information added by Drupal.org packaging script on 2014-10-04
+version = "7.x-2.0-alpha4"
+core = "7.x"
+project = "media"
+datestamp = "1412422430"
+
diff --git a/drupal7/sites/all/modules/media/modules/media_migrate_file_types/media_migrate_file_types.module b/drupal7/sites/all/modules/media/modules/media_migrate_file_types/media_migrate_file_types.module
new file mode 100644
index 00000000..c9c6d46c
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_migrate_file_types/media_migrate_file_types.module
@@ -0,0 +1,73 @@
+<?php
+
+/**
+ * @file
+ * Primarily Drupal hooks.
+ */
+
+/*
+ * Implements hook_system_info_alter()
+ */
+function media_migrate_file_types_system_info_alter(&$info, $file, $type) {
+  if ($type == 'module' && $file->name == 'media_migrate_file_types') {
+    $info['hidden'] = FALSE;
+  }
+}
+
+/**
+ * Implements hook_menu().
+ */
+function media_migrate_file_types_menu() {
+  $items['admin/structure/file-types/upgrade'] = array(
+    'title' => 'Upgrade types',
+    'page callback' => 'drupal_get_form',
+    'page arguments' => array('media_migrate_file_types_upgrade_file_types'),
+    'access arguments' => array('administer file types'),
+    'file' => 'includes/media_migrate_file_types.pages.inc',
+    'type' => MENU_CALLBACK,
+  );
+  $items['admin/structure/file-types/upgrade/confirm'] = array(
+    'title' => 'Upgrade types',
+    'page callback' => 'drupal_get_form',
+    'page arguments' => array('media_migrate_file_types_upgrade_file_types_confirm'),
+    'access arguments' => array('administer file types'),
+    'file' => 'includes/media_migrate_file_types.pages.inc',
+    'type' => MENU_CALLBACK,
+  );
+
+  return $items;
+}
+
+/**
+ * Implements hook_help().
+ */
+function media_migrate_file_types_help($path, $arg) {
+  switch ($path) {
+    case 'admin/structure/file-types':
+      if (_media_migrate_file_types_get_migratable_file_types()) {
+        drupal_set_message(t('There are disabled/deleted file types that can be migrated to their new alternatives. Visit <a href="!url">migration page</a> to get more information.', array('!url' => url('admin/structure/file-types/upgrade'))));
+      }
+      break;
+  }
+}
+
+/**
+ * Checks if there are any files that belong to disabled or deleted file
+ * types.
+ *
+ * @return Array of file types (machine names) that are candidates for
+ *   migration.
+ */
+function _media_migrate_file_types_get_migratable_file_types() {
+  $query = db_select('file_managed', 'f')
+    ->fields('f', array('type'))
+    ->distinct();
+  $types = $query->execute()->fetchCol();
+
+  $enabled_types = array();
+  foreach (file_type_get_enabled_types() as $type) {
+    $enabled_types[] = $type->type;
+  }
+
+  return array_diff($types, $enabled_types);
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/includes/media_wysiwyg.file_usage.inc b/drupal7/sites/all/modules/media/modules/media_wysiwyg/includes/media_wysiwyg.file_usage.inc
new file mode 100644
index 00000000..cbc1e841
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/includes/media_wysiwyg.file_usage.inc
@@ -0,0 +1,179 @@
+<?php
+
+/**
+ * @file
+ * Functions related to the tracking the file usage of embedded media.
+ */
+
+/**
+ * Implements hook_field_attach_insert().
+ *
+ * Track file usage for media files included in formatted text. Note that this
+ * is heavy-handed, and should be replaced when Drupal's filter system is
+ * context-aware.
+ */
+function media_wysiwyg_field_attach_insert($entity_type, $entity) {
+  _media_wysiwyg_filter_add_file_usage_from_fields($entity_type, $entity);
+}
+
+/**
+ * Implements hook_field_attach_update().
+ *
+ * @see media_field_attach_insert().
+ */
+function media_wysiwyg_field_attach_update($entity_type, $entity) {
+  _media_wysiwyg_filter_add_file_usage_from_fields($entity_type, $entity);
+}
+
+/**
+ * Add file usage from file references in an entity's text fields.
+ */
+function _media_wysiwyg_filter_add_file_usage_from_fields($entity_type, $entity) {
+  // Track the total usage for files from all fields combined.
+  $entity_files = media_wysiwyg_entity_field_count_files($entity_type, $entity);
+
+  list($entity_id, $entity_vid, $entity_bundle) = entity_extract_ids($entity_type, $entity);
+
+  // When an entity has revisions and then is saved again NOT as new version the
+  // previous revision of the entity has be loaded to get the last known good
+  // count of files. The saved data is compared against the last version
+  // so that a correct file count can be created for that (the current) version
+  // id. This code may assume some things about entities that are only true for
+  // node objects. This should be reviewed.
+  // @TODO this conditional can probably be condensed
+  if (empty($entity->revision) && empty($entity->old_vid) && empty($entity->is_new) && ! empty($entity->original)) {
+    $old_files = media_wysiwyg_entity_field_count_files($entity_type, $entity->original);
+    foreach ($old_files as $fid => $old_file_count) {
+      // Were there more files on the node just prior to saving?
+      if (empty($entity_files[$fid])) {
+        $entity_files[$fid] = 0;
+      }
+      if ($old_file_count > $entity_files[$fid]) {
+        $deprecate = $old_file_count - $entity_files[$fid];
+        // Now deprecate this usage
+        $file = file_load($fid);
+        if ($file) {
+          file_usage_delete($file, 'media', $entity_type, $entity_id, $deprecate);
+        }
+        // Usage is deleted, nothing more to do with this file
+        unset($entity_files[$fid]);
+      }
+      // There are the same number of files, nothing to do
+      elseif ($entity_files[$fid] ==  $old_file_count) {
+        unset($entity_files[$fid]);
+      }
+      // There are more files now, adjust the difference for the greater number.
+      // file_usage incrementing will happen below.
+      else {
+        // We just need to adjust what the file count will account for the new
+        // images that have been added since the increment process below will
+        // just add these additional ones in
+        $entity_files[$fid] = $entity_files[$fid] - $old_file_count;
+      }
+    }
+  }
+
+  // Each entity revision counts for file usage. If versions are not enabled
+  // the file_usage table will have no entries for this because of the delete
+  // query above.
+  foreach ($entity_files as $fid => $entity_count) {
+    if ($file = file_load($fid)) {
+      file_usage_add($file, 'media', $entity_type, $entity_id, $entity_count);
+    }
+  }
+}
+
+/**
+ * Parse file references from an entity's text fields and return them as an array.
+ */
+function media_wysiwyg_filter_parse_from_fields($entity_type, $entity) {
+  $file_references = array();
+
+  foreach (media_wysiwyg_filter_fields_with_text_filtering($entity_type, $entity) as $field_name) {
+    if ($field_items = field_get_items($entity_type, $entity, $field_name)) {
+      foreach ($field_items as $field_item) {
+        preg_match_all(MEDIA_WYSIWYG_TOKEN_REGEX, $field_item['value'], $matches);
+        foreach ($matches[0] as $tag) {
+          $tag = str_replace(array('[[', ']]'), '', $tag);
+          $tag_info = drupal_json_decode($tag);
+          if (isset($tag_info['fid']) && $tag_info['type'] == 'media') {
+            $file_references[] = $tag_info;
+          }
+        }
+
+        preg_match_all(MEDIA_WYSIWYG_TOKEN_REGEX, $field_item['value'], $matches_alt);
+        foreach ($matches_alt[0] as $tag) {
+          $tag = urldecode($tag);
+          $tag_info = drupal_json_decode($tag);
+          if (isset($tag_info['fid']) && $tag_info['type'] == 'media') {
+            $file_references[] = $tag_info;
+          }
+        }
+      }
+    }
+  }
+
+  return $file_references;
+}
+
+/**
+ * Utility function to get the file count in this entity
+ *
+ * @param type $entity
+ * @param type $entity_type
+ * @return int
+ */
+function media_wysiwyg_entity_field_count_files($entity_type, $entity) {
+  $entity_files = array();
+  foreach (media_wysiwyg_filter_parse_from_fields($entity_type, $entity) as $file_reference) {
+    if (empty($entity_files[$file_reference['fid']])) {
+      $entity_files[$file_reference['fid']] = 1;
+    }
+    else {
+      $entity_files[$file_reference['fid']]++;
+    }
+  }
+  return $entity_files;
+}
+
+/**
+ * Implements hook_entity_delete().
+ */
+function media_wysiwyg_entity_delete($entity, $type) {
+  list($entity_id) = entity_extract_ids($type, $entity);
+
+  db_delete('file_usage')
+    ->condition('module', 'media')
+    ->condition('type', $type)
+    ->condition('id', $entity_id)
+    ->execute();
+}
+
+/**
+ * Implements hook_field_attach_delete_revision().
+ *
+ * @param type $entity_type
+ * @param type $entity
+ */
+function media_wysiwyg_field_attach_delete_revision($entity_type, $entity) {
+  list($entity_id) = entity_extract_ids($entity_type, $entity);
+  $files = media_wysiwyg_entity_field_count_files($entity_type, $entity);
+  foreach ($files as $fid => $count) {
+    if ($file = file_load($fid)) {
+      file_usage_delete($file, 'media', $entity_type , $entity_id, $count);
+    }
+  }
+}
+
+/**
+ * Implements hook_entity_dependencies().
+ */
+function media_wysiwyg_entity_dependencies($entity, $entity_type) {
+  // Go through all the entity's text fields and add a dependency on any files
+  // that are referenced there.
+  $dependencies = array();
+  foreach (media_wysiwyg_filter_parse_from_fields($entity_type, $entity) as $file_reference) {
+    $dependencies[] = array('type' => 'file', 'id' => $file_reference['fid']);
+  }
+  return $dependencies;
+}
